/******************************************************************************

Common string functions

******************************************************************************/
// remove blank chapacter from string. For example, "a b c" will be 
// refined to "abc".
function removeSpace(origStr) {
    var reg = /\s/g;
    return origStr.replace(reg, '');
}

function StrToInt(strVal)
{
    return parseInt(strVal);
}

function isUndefined(value)
{
    if(typeof(value)=='undefined') {
        return true;
    }
    else {
        return false;
    }        
}

/******************************************************************************

JSON functions

******************************************************************************/
function jsonEncodeString(label, value) {    
    var tmpVal = "\""+label+"\"";
    tmpVal += ":";
    tmpVal +="\""+value+"\"";
    
    return tmpVal;
}

function jsonEncodeNumber(label, number) {    
    var tmpVal = "\""+label+"\"";
    tmpVal += ":";    
    if( null == number || 0 == number || "" == number)
    {
        tmpVal += "0";    
    }
    else
    {
        tmpVal += number;
    }
    
    return tmpVal;
}

function jsonEncodeBool(label, boolVal) {
    var tmpVal = "\""+label+"\"";
    tmpVal += ":";
    if( boolVal == true )
    {
        tmpVal += 1;    
    }
    else
    {
        tmpVal += 0;
    }
    
    return tmpVal;
}

/******************************************************************************

Alert functions

******************************************************************************/
function alertError(errorCont)
{
    bs4pop.notice(errorCont, {position: 'center'}, {type: 'danger'});
}

function alertInfo(infoCont)
{    
    bs4pop.notice(infoCont, {position: 'center'}, {type: 'primary'});
}


/******************************************************************************

UI functions

******************************************************************************/
function getURLVars() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for(var i = 0; i < hashes.length; i++)
    {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function addCookie(name, value)
{
    var cookieStr = name + "=" + encodeURIComponent(value);
    document.cookie = cookieStr+ ';SameSite=Lax';
}

function getCookie(name)
{
    var strcookie=document.cookie;
    var arrcookie=strcookie.split("; ");
    for(var i=0;i<arrcookie.length;i++)
    {
        var arr=arrcookie[i].split("=");
        if( arr[0]==name )  {
            return decodeURIComponent(arr[1]);
        }
    }
    return null;
}

function addIndexToCookie(indexStr)
{
    addCookie("mssIndexStr", indexStr);
}

function getIndexVarFromCookie(name)
{
    var indexStr = getCookie("mssIndexStr");
    if( null == indexStr || "" == indexStr )
    {
        return null;
    }
    
    indexStr = decodeURIComponent(indexStr);
    
    var attrcookie = indexStr.split('&');
    var attrCnt = attrcookie.length;
    for(var i = 0; i < attrCnt; i++)
    {
        var attr=attrcookie[i].split("=");
        if(attr[0]==name)
        {
            return attr[1];
        }
    }
    return null;
}

function delIndexFromCookie()
{
    addIndexToCookie("");
}


function loadHtmlPage(url)
{  
    $.ajax({
        type:   "get",
        url:    url,
        cache:  false,
        success:    function(msg)   {            
            $("#mainWindowHtmlPage").empty();
            $("#mainWindowHtmlPage").html(msg);
        }
    });    
} 

function jumpToNewPage(new_url)  {
    window.location.href=new_url;
}

function divShow(objID) {
    $("#"+objID).show();
}

function divHide(objID) {
    $("#"+objID).hide();
}

function disableEditBox(edtbox_name) {
    $("#"+edtbox_name).attr("disabled", "disabled");
}

function enableEditBox(edtbox_name) {
    $("#"+edtbox_name).removeAttr("disabled");
}

function editBoxHasValue(edtbox_name) {
    var value = $("#"+edtbox_name).val()    
    if( value==null || value=="" ) {
        return false;
    }
    else {
        return true;
    }    
}

function editBoxValue(edtbox_name) {
    var value = $("#"+edtbox_name).val();
    if( value==null ) {
        return "";
    }
    
    return value; //encodeURIComponent(value);
}

function editBoxValueWithoutSpace(edtbox_name) {
    var value = $("#"+edtbox_name).val();
    if( value==null ) {
        return "";
    }   
    value = removeSpace(value);    
    return value; // encodeURIComponent(value);
}

function editBoxIntValue(edtbox_name) {
    var value = $("#"+edtbox_name).val();
    if( value==null || value=="" ) {
        return encodeURIComponent(0);
    }

    value = removeSpace(value);
    return encodeURIComponent(StrToInt(value));
}

function editBoxSetIntValue(edtbox_name, intval) {
    let value = parseInt(intval);
    if( value==0 || value==null ) {
        $("#"+edtbox_name).val('');
    }
    else {
        $("#"+edtbox_name).val(value);
    }
}

function inputHasChecked(input_name) {
    var value = $("#"+input_name).prop("checked");
    
    if( "checked"==value || true==value ) {
        return true;
    }
    else {
        return false;
    }
}

function setInputChecked(input_name) {
    return $("#"+input_name).attr("checked", true);
};

function setInputCheckAttr(input_name, value) {
    if( null==value || value <= 0 ) {
        removeInputChecked(input_name);
    }
    else {
        setInputChecked(input_name);
    }
}

function removeInputChecked(input_name) {
    return $("#"+input_name).removeAttr("checked");
}

function checkBoxIntVal(checkbox_name) {
    if( inputHasChecked(checkbox_name) ) {
        return 1;
    }
    else {
        return 0;
    }
}

function InputToInt(input_name) {
    var value = $("#"+input_name).val();
    if( null==value || !value.length ) {
        return 0;
    }
    
    return StrToInt(value);
}

function dataListAdd(dlID, value, text) {
    $('#'+dlID).append(`<option value='${value}'>${text}</option>`);
}


/******************************************************************************

Page functions

******************************************************************************/
var pageIndex = 0;
var pageNav = 0;    // 0: go previous; 1: go next;

function pagePrevious(pageInfoFunc) {
    pageNav=0;
    pageIndex--;
    pageInfoFunc();
};

function pageNext(pageInfoFunc) {
    pageNav=1;
    pageIndex++;
    pageInfoFunc();
};

function pageCurr() {
    return pageIndex;
}

function pageReset() {
    pageIndex = 0;
    pageNav = 0;
}

function pageRollback() {
    if( 0==pageNav )
    {
        pageIndex++;
    }
    else
    {
        pageIndex--;
    }
}

function alertListError() {
    pageRollback();
    alertNoMoreRecord();
}