function buildIndexStr(extLine) {
    return hex_md5("extLine="+extLine);
}

function getExtLineListResp(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();

    $.each(data, function(index, ev) {
        var indexStr = buildIndexStr(ev.extLine);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        $("#"+indexStr).append("<td>"+ev.extLine+"</td>");
        
        if( 0 == ev.state )
        {
            $("#"+indexStr).append("<td>"+"<img src='/shared/img/extline_off.png' />"+"</td>");
        }
        else
        {
            $("#"+indexStr).append("<td>"+"<img src='/shared/img/extline_on.png' />"+"</td>");
        }
        
        $("#"+indexStr).append("<td>"+ev.description+"</td>");
        $("#"+indexStr).append("<td>"+ev.host+"</td>");
        $("#"+indexStr).append("<td>"+ev.port+"</td>");
        $("#"+indexStr).append("<td>"+translateSipTransport(ev.transport)+"</td>");
        $("#"+indexStr).append("<td>"+ev.localUser+"</td>");
        $("#"+indexStr).append("<td>"+addBtnEdit(`editExtLine('${ev.extLine}')`)
                                       +addBtnDel(`delExtLine('${ev.extLine}')`)+"</td>");
    });
    
}

function getExtLineList(currIndex) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/extline/list",
        type: "get",
        dataType: "json",
        data:      {content:jsonStr},
        success: getExtLineListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
}

function gotoPrevList() {
    pagePrevious(getExtLineList);
}

function gotoNextList() {
    pageNext(getExtLineList);
}

function getExtLineDetailResp(data) {
    $.each(data, function(index, ev) {
        
        $("#extLine").val(ev.extLine);
        $("#description").val(ev.description);
                
        if( 0 == ev.type )
        {
            setInputChecked("sipServerType");
        }
        else
        {
            setInputChecked("fxoType");
        }
        
        $("#host").val(ev.host);
        $("#port").val(ev.port);
        $("#transport").val(ev.transport);        
        $("#password").val(ev.password);
        $("#authID").val(ev.authID);
        $("#maxCalls").val(ev.maxCalls);
        $("#localUser").val(ev.localUser);
        
        $("#chain").val(ev.chain);
        editBoxSetIntValue('otcID',     ev.otcID);
        editBoxSetIntValue('ogGroupID', ev.ogGroupID);  
        editBoxSetIntValue('maxMOCalls',ev.maxMOCalls);      
        editBoxSetIntValue('maxDur',    ev.maxDur);      
        editBoxSetIntValue('noAnsTimer',ev.noAnsTimer);
                
        if( 0 == ev.aaInd )
        {
            setInputChecked("localUserInd");
        }
        else
        {
            setInputChecked("aaInd");
        } 
        setInputCheckAttr("authidWithAddrInd", ev.authidWithAddrInd);
        setInputCheckAttr("disable100RelInd", ev.disable100RelInd);
        setInputCheckAttr("reInviteInd", ev.reInviteInd);
        setInputCheckAttr("donotRegInd", ev.donotRegInd);
        setInputCheckAttr("incomingLI", ev.incomingLI);
        setInputCheckAttr("shareInd", ev.shareInd);
        setInputCheckAttr("origCallerNbr", ev.origCallerNbr);
        
        setInputCheckAttr("outbandInd", ev.outbandInd);        
        $("#outbandServer").val(ev.outbandServer);
        $("#outbandPort").val(ev.outbandPort);
        $("#reqURIParam").val(ev.reqURIParam);
        
        // update UI
        extLineTypeOnClick();
        rtTypeOnClick();
        outbandIndOnClick();
        updateUI();
    });
}
    
function getExtLineDetail(extLine) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("extLine", extLine);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/extline/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getExtLineDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
}

function delExtLine(ext_line) {
    var indexStr = buildIndexStr(ext_line);
    var jsonStr = "{";
    jsonStr += jsonEncodeString("extLine", ext_line);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/extline/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {           
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
}

function updateExtLineDetail() {
    var jsonStr = "{";
    
    if( inputHasChecked("sipServerType") )
    {
        jsonStr += jsonEncodeNumber("type",0)+",";
    }
    else
    {
        jsonStr += jsonEncodeNumber("type",1)+",";
    }
    
    jsonStr += jsonEncodeString("extLine", $("#extLine").val())+",";
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeString("host", $("#host").val())+",";
    jsonStr += jsonEncodeNumber("port",$("#port").val())+",";
    jsonStr += jsonEncodeNumber("transport",$("#transport").val())+",";
    jsonStr += jsonEncodeString("password", $("#password").val())+",";
    jsonStr += jsonEncodeString("authID", $("#authID").val())+",";
    jsonStr += jsonEncodeString("localUser", $("#localUser").val())+",";
    jsonStr += jsonEncodeString("outbandServer", $("#outbandServer").val())+",";
    jsonStr += jsonEncodeNumber("outbandPort",$("#outbandPort").val())+",";
    jsonStr += jsonEncodeString("reqURIParam", $("#reqURIParam").val())+",";
    
    if( inputHasChecked("aaInd") )
    {
        jsonStr += jsonEncodeNumber("aaInd",1)+",";
    }
    
    if( inputHasChecked("outbandInd") )
    {
        jsonStr += jsonEncodeNumber("outbandInd",1)+",";
    }
    
    if( inputHasChecked("authidWithAddrInd") )
    {
        jsonStr += jsonEncodeNumber("authidWithAddrInd",1)+",";
    }

    if( inputHasChecked("disable100RelInd") )
    {
        jsonStr += jsonEncodeNumber("disable100RelInd",1)+",";
    }
    
    if( inputHasChecked("reInviteInd") )
    {
        jsonStr += jsonEncodeNumber("reInviteInd",1)+",";
    }
    
    if( inputHasChecked("donotRegInd") )
    {
        jsonStr += jsonEncodeNumber("donotRegInd", 1)+",";
    }
    
    if( inputHasChecked("incomingLI") )
    {
        jsonStr += jsonEncodeNumber("incomingLI", 1)+",";
    }
        
    if( inputHasChecked("shareInd") )
    {
        jsonStr += jsonEncodeNumber("shareInd",1)+",";
    }
    
    if( inputHasChecked("origCallerNbr") )
    {
        jsonStr += jsonEncodeNumber("origCallerNbr",1)+",";
    }
    
    jsonStr += jsonEncodeString("chain", $("#chain").val())+",";
    jsonStr += jsonEncodeNumber("otcID",        editBoxIntValue('otcID'))+",";
    jsonStr += jsonEncodeNumber("ogGroupID",    editBoxIntValue('ogGroupID'))+",";
    jsonStr += jsonEncodeNumber("maxCalls",     editBoxIntValue('maxCalls'))+",";
    jsonStr += jsonEncodeNumber("maxMOCalls",   editBoxIntValue('maxMOCalls'))+",";
    jsonStr += jsonEncodeNumber("maxDur",       editBoxIntValue('maxDur'))+",";
    jsonStr += jsonEncodeNumber("noAnsTimer",   editBoxIntValue('noAnsTimer'))+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/extline/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            switch(data.errorCode) {
                case 0: 
                    alertOperationSuccess();
                    break;

                case -2:
                    alertLocalUserWithSameName();
                    break;

                default:
                    alertOperationFail();
                    break;
            }   
            loadHtmlPage("/uiExtLine.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiExtLine.html");
        }
    });
}

/****************************************************

Functions for UI and Dialog

****************************************************/
function updateUI() {
    if(inputHasChecked("sipServerType")) {
        divShow("serverAddrInfo");
        divShow("opxyItems")
    }
    else {
        divHide("serverAddrInfo");
        divHide("opxyItems");
    }
}

function addBtnOnClick() {
    delIndexFromCookie();
    
    loadHtmlPage("/uiExtLineDlg.html");
}

function editExtLine(ext_line) {
    var dataPost = "extName="+encodeURIComponent(ext_line);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiExtLineDlg.html");
}

function cancelBtnOnClick() {    
    loadHtmlPage("/uiExtLine.html");
}

function rtTypeOnClick() {
    if(inputHasChecked("aaInd")) {
        disableEditBox("localUser");
    }
    else {
        enableEditBox("localUser");
    }
}

function extLineTypeOnClick() {
    updateUI();
}

function outbandIndOnClick() {
    if(inputHasChecked("outbandInd")) {
        enableEditBox("outbandServer");
        enableEditBox("outbandPort");
    }
    else {
        disableEditBox("outbandServer");
        disableEditBox("outbandPort");
    }
}
