/*
Functions for local users UI and table
*/

getLocalUserListResp=function(data) {   
    //console.log(data);     
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    
    $("#dataRecords").empty();    
    
    $.each(data, function(index, ev) {
        var indexStr = ev.usrname;

        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        $("#"+indexStr).append("<td>"+ev.usrname+"</td>");
        
        switch(ev.state)
        {
            case 1:
                $("#"+indexStr).append("<td>"+"<img src='/shared/img/idle_user.png' />"+"</td>");
                break;
            
            case 2:
                $("#"+indexStr).append("<td>"+"<img src='/shared/img/alert_user.png' />"+"</td>");
                break;
                
            case 3:
                $("#"+indexStr).append("<td>"+"<img src='/shared/img/talk_user.png' />"+"</td>");
                break;

            default:
                $("#"+indexStr).append("<td>"+"<img src='/shared/img/offline_user.png' />"+"</td>");
                break;
        }
        $("#"+indexStr).append("<td>"+ev.description+"</td>");
        $("#"+indexStr).append("<td>"+ev.dispname+"</td>");
        $("#"+indexStr).append("<td>"+ev.addr+"</td>");
        $("#"+indexStr).append("<td>"+ev.userAgent+"</td>");
        $("#"+indexStr).append("<td>"+addBtnEdit(`editLocalUser('${ev.usrname}')`)
                                     +addBtnDel(`delLocalUser('${ev.usrname}')`)+"</td>");                      
    });
    
};

getLocalUserList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/localuser/list",
        type: "get",
        dataType: "json",
        data:      {content:jsonStr},        
        success: getLocalUserListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

delLocalUser=function(usr_name) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("usrname", usr_name);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/localuser/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {           
            $('#'+usr_name).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

getLocalUserDetailResp=function(data) {    
    if(data.errorCode && 0>data.errorCode ) {
        alertOperationFail();
        loadHtmlPage("/uiLocalUser.html");
        return;
    }

    $.each(data, function(index, ev) {
        $("#edtUsrPwd").val(ev.usrpwd);
        $("#edtDesc").val(ev.description);
        $("#edtIPAddr").val(ev.addr);
        $("#edtIPPort").val(ev.port);
        $("#edtDispName").val(ev.dispname);
        $("#edtEmailAddr").val(ev.email);
        
        $("#edtCFU").val(ev.cfunbr);
        $("#edtCFNC").val(ev.cfncnbr);
        $("#edtCFB").val(ev.cfbnbr);
        $("#edtCFNA").val(ev.cfnanbr);
        $("#edtCFNATmr").val(ev.cfnatmr);
                
        $("#edtRGID").val(ev.ringgrpid);
        $("#edtPickUPID").val(ev.pickupgrpid);
        
        switch( ev.fmtype )
        {
            case 1:
                setInputChecked("optFmSameTime");                
                break;
            
            case 2:
                setInputChecked("optFmNoAns");   
                break;
            
            case 3:
                setInputChecked("optFmInterval");  
                break;
            
            default:
                break;
        }
        $("#edtFMInterval").val(ev.fminterval);
        $("#edtFMDestA").val(ev.fmdesta);
        $("#edtFMDestB").val(ev.fmdestb);
        $("#edtFMDestC").val(ev.fmdestc);
        
        $("#edtPresenceID").val(ev.presgrpid);
        
        var callLevel = ev.calllevel;
        
        var tmpVal = callLevel&(0x01<<1 );
        setInputCheckAttr("chkCallLevel1", tmpVal);

        tmpVal = callLevel&(0x01<<2 );
        setInputCheckAttr("chkCallLevel2", tmpVal);

        tmpVal = callLevel&(0x01<<3);
        setInputCheckAttr("chkCallLevel3", tmpVal);

        tmpVal = callLevel&(0x01<<4);
        setInputCheckAttr("chkCallLevel4", tmpVal);

        tmpVal = callLevel&(0x01<<5);
        setInputCheckAttr("chkCallLevel5", tmpVal);

        tmpVal = callLevel&(0x01<<6);
        setInputCheckAttr("chkCallLevel6", tmpVal);

        $("#edtDialPlan").val(ev.dialPlan);
        $("#edtExtLine").val(ev.specextline);
        $("#edtMaxDuration").val(ev.maxdura);
        $("#maxcall").val(ev.maxcall);
        $("#momaxcall").val(ev.momaxcall);
        $("#edtEndDate").val(ev.enddate);
        editBoxSetIntValue('edtTCID', ev.tcID);
        
        setInputCheckAttr("chkCFU", ev.right_cfu);
        setInputCheckAttr("chkCFNR", ev.right_cfnc);
        setInputCheckAttr("chkCFB", ev.right_cfb);
        setInputCheckAttr("chkCFNA", ev.right_cfna);
        setInputCheckAttr("chkVMS", ev.right_vms);
        setInputCheckAttr("chkAA", ev.right_aa);        
        setInputCheckAttr("chkSuppressRG", ev.right_sup_rg);        
        setInputCheckAttr("chkCallPark", ev.right_park);
        setInputCheckAttr("chkCallRetrieve", ev.right_retrieve);
        setInputCheckAttr("chkCallerPrepaid", ev.right_prepaid);
        setInputCheckAttr("chkCallShop", ev.right_callshop);
        setInputCheckAttr("chkCallerID", ev.right_clrid);
        setInputCheckAttr("chkSubscribe", ev.right_subpre);
        setInputCheckAttr("chkMOH", ev.right_moh);
        setInputCheckAttr("chkRelay", ev.right_relay);
        setInputCheckAttr("chkOLI", ev.right_oli);
        setInputCheckAttr("chkTLI", ev.right_tli);
        setInputCheckAttr("chkCW", ev.right_cw);
        setInputCheckAttr("chkIPAuth", ev.right_ipauth);
        setInputCheckAttr("chkOneNbr", ev.right_onenbr);
        setInputCheckAttr("chkBreakIn", ev.right_breakin);
        setInputCheckAttr("chkOverstep", ev.right_overstep);
        
        updateUI();

    });    
};

getLocalUserDetail=function(usr_name) {
    var jsonStr = "{";
    jsonStr += jsonEncodeString("usrname", usr_name);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/localuser/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getLocalUserDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

checkParamsValid=function() {
    if( editBoxHasValue("edtUsrName") == false )
    {
        return "Invalid user name";
    }
    
    return "ok"
};

updateLocalUserDetail=function() {
    var checkResult = checkParamsValid();
    if( "ok" != checkResult )
    {
        alertError(checkResult);
        return;
    }
    
    var usrInfoJson = "{";
    
    usrInfoJson += jsonEncodeString("usrname", $("#edtUsrName").val())+",";     
    usrInfoJson += jsonEncodeString("usrpwd", $("#edtUsrPwd").val())+",";  
    usrInfoJson += jsonEncodeString("description", $("#edtDesc").val())+","; 
    usrInfoJson += jsonEncodeString("addr", $("#edtIPAddr").val())+",";
    usrInfoJson += jsonEncodeNumber("port",$("#edtIPPort").val())+",";
    usrInfoJson += jsonEncodeString("dispname", $("#edtDispName").val())+","; 
    usrInfoJson += jsonEncodeString("email", $("#edtEmailAddr").val())+",";

    usrInfoJson += jsonEncodeString("cfunbr", $("#edtCFU").val())+",";
    usrInfoJson += jsonEncodeString("cfncnbr", $("#edtCFNC").val())+",";
    usrInfoJson += jsonEncodeString("cfbnbr", $("#edtCFB").val())+",";
    usrInfoJson += jsonEncodeString("cfnanbr", $("#edtCFNA").val())+",";
    if( true == editBoxHasValue("edtCFNATmr") )
    {
        usrInfoJson += jsonEncodeNumber("cfnatmr",$("#edtCFNATmr").val())+",";
    }
        
    usrInfoJson += jsonEncodeNumber("ringgrpid",$("#edtRGID").val())+",";
    usrInfoJson += jsonEncodeNumber("pickupgrpid",$("#edtPickUPID").val())+",";
    
    if( inputHasChecked("optFmSameTime") )
    {
        usrInfoJson += jsonEncodeNumber("fmtype",1)+",";
    }
    else if( inputHasChecked("optFmNoAns") )
    {
        usrInfoJson += jsonEncodeNumber("fmtype",2)+",";
    }
    else
    {
        usrInfoJson += jsonEncodeNumber("fmtype",3)+",";
    }
    
    if( true == editBoxHasValue("edtFMInterval") )
    {
        usrInfoJson += jsonEncodeNumber("fminterval",$("#edtFMInterval").val())+",";
    }
    
    usrInfoJson += jsonEncodeString("fmdesta", $("#edtFMDestA").val())+",";
    usrInfoJson += jsonEncodeString("fmdestb", $("#edtFMDestB").val())+",";
    usrInfoJson += jsonEncodeString("fmdestc", $("#edtFMDestC").val())+",";
    
    if( true == editBoxHasValue("edtPresenceID") )
    {
        usrInfoJson += jsonEncodeNumber("presgrpid",$("#edtPresenceID").val())+",";
    }
    
    var callLevel=0;    
    if( inputHasChecked("chkCallLevel1") )
    {
        callLevel += 0x01<<1;
    }
    if( inputHasChecked("chkCallLevel2") )
    {
        callLevel += 0x01<<2;
    }
    if( inputHasChecked("chkCallLevel3") )
    {
        callLevel += 0x01<<3;
    }
    if( inputHasChecked("chkCallLevel4") )
    {
        callLevel += 0x01<<4;
    }
    if( inputHasChecked("chkCallLevel5") )
    {
        callLevel += 0x01<<5;
    }
    if( inputHasChecked("chkCallLevel6") )
    {
        callLevel += 0x01<<6;
    }
    if( 0 < callLevel )
    {
        usrInfoJson += jsonEncodeNumber("calllevel", callLevel)+",";
    }
    
    usrInfoJson += jsonEncodeString("dialplan", $("#edtDialPlan").val())+",";
    
    usrInfoJson += jsonEncodeString("specextline", $("#edtExtLine").val())+",";
    
    usrInfoJson += jsonEncodeNumber("maxdura", $("#edtMaxDuration").val())+",";

    usrInfoJson += jsonEncodeNumber("maxcall", $("#maxcall").val())+",";
    usrInfoJson += jsonEncodeNumber("momaxcall", $("#momaxcall").val())+",";
    
    usrInfoJson += jsonEncodeNumber("enddate", $("#edtEndDate").val())+",";
    
    usrInfoJson += jsonEncodeNumber("tcID", editBoxIntValue("edtTCID"))+",";
    
    // service rights 
    if( inputHasChecked("chkCFU") )
    {
        usrInfoJson += jsonEncodeNumber("right_cfu", 1)+",";
    }
    if( inputHasChecked("chkCFNR") )
    {
        usrInfoJson += jsonEncodeNumber("right_cfnc", 1)+",";
    }
    if( inputHasChecked("chkCFB") )
    {
        usrInfoJson += jsonEncodeNumber("right_cfb", 1)+",";
    }
    if( inputHasChecked("chkCFNA") )
    {
        usrInfoJson += jsonEncodeNumber("right_cfna", 1)+",";
    }
    if( inputHasChecked("chkVMS") )
    {
        usrInfoJson += jsonEncodeNumber("right_vms", 1)+",";
    }
    if( inputHasChecked("chkAA") )
    {
        usrInfoJson += jsonEncodeNumber("right_aa", 1)+",";
    }
   
    if( inputHasChecked("chkSuppressRG") )
    {
        usrInfoJson += jsonEncodeNumber("right_sup_rg", 1)+",";
    }
    
    if( inputHasChecked("chkCallPark") )
    {
        usrInfoJson += jsonEncodeNumber("right_park", 1)+",";
    }
    if( inputHasChecked("chkCallRetrieve") )
    {
        usrInfoJson += jsonEncodeNumber("right_retrieve", 1)+",";
    }
    if( inputHasChecked("chkCallerPrepaid") )
    {
        usrInfoJson += jsonEncodeNumber("right_prepaid", 1)+",";
    }
    if( inputHasChecked("chkCallShop") )
    {
        usrInfoJson += jsonEncodeNumber("right_callshop", 1)+",";
    }
    if( inputHasChecked("chkCallerID") )
    {
        usrInfoJson += jsonEncodeNumber("right_clrid", 1)+",";
    }
    if( inputHasChecked("chkSubscribe") )
    {
        usrInfoJson += jsonEncodeNumber("right_subpre", 1)+",";
    }
    if( inputHasChecked("chkMOH") )
    {
        usrInfoJson += jsonEncodeNumber("right_moh", 1)+",";
    }
    if( inputHasChecked("chkRelay") )
    {
        usrInfoJson += jsonEncodeNumber("right_relay", 1)+",";
    }
    if( inputHasChecked("chkOLI") )
    {
        usrInfoJson += jsonEncodeNumber("right_oli", 1)+",";
    }
    if( inputHasChecked("chkTLI") )
    {
        usrInfoJson += jsonEncodeNumber("right_tli", 1)+",";
    }
    if( inputHasChecked("chkCW") )
    {
        usrInfoJson += jsonEncodeNumber("right_cw", 1)+",";
    }
    if( inputHasChecked("chkIPAuth") )
    {
        usrInfoJson += jsonEncodeNumber("right_ipauth", 1)+",";
    }
    if( inputHasChecked("chkOneNbr") )
    {
        usrInfoJson += jsonEncodeNumber("right_onenbr", 1)+",";
    }
    if( inputHasChecked("chkBreakIn") )
    {
        usrInfoJson += jsonEncodeNumber("right_breakin", 1)+",";
    }
    if( inputHasChecked("chkOverstep") )
    {
        usrInfoJson += jsonEncodeNumber("right_overstep", 1)+",";
    }
    
    
    usrInfoJson += jsonEncodeString("endjson", "yes");
    
    usrInfoJson += "}";
    
    $.ajax({
        url:  "/dbajax/localuser/set",
        type: "get",
        data: {content:usrInfoJson},
        dataType: "json",        
        success: function(data) {
            switch(data.errorCode) {
                case 0: 
                    alertOperationSuccess();
                    break;

                case -4:
                    alertExtLineWithSameName();
                    break;

                default:
                    alertOperationFail();
                    break;
            }            
            loadHtmlPage("/uiLocalUser.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiLocalUser.html");
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie();
    loadHtmlPage("/uiLocalUserDlg.html");
};

gotoPrevList=function() {
    pagePrevious(getLocalUserList);
};

gotoNextList=function() {
    pageNext(getLocalUserList);
};

editLocalUser=function(usr_name) {
    var dataPost = "usrname="+encodeURIComponent(usr_name);    
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiLocalUserDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiLocalUser.html");
};

function dl_local_user(record) {
    var value = record.usrName;
    var text  = record.usrName + " " + record.description;     
    dataListAdd('cfuList',  value, text);
    dataListAdd('cfncList', value, text);
    dataListAdd('cfbList',  value, text);
    dataListAdd('cfnaList', value, text);
}

function dl_local_users() {
    dl_local_user_cb(dl_local_user);
}

function enableIPAuthItems() {
    enableEditBox("edtIPAddr");
    enableEditBox("edtIPPort");
}

function disableIPAuthItems() {
    disableEditBox("edtIPAddr");
    disableEditBox("edtIPPort");
}

function chkIPAuthOnClick() {
    if(inputHasChecked("chkIPAuth"))
    {
        enableIPAuthItems();
    }
    else
    {
        disableIPAuthItems();
    }
}

function updateUI()
{
    chkIPAuthOnClick();
}