
buildIndexStr=function(dialPlan, calledNbr) {
    return hex_md5("dialPlan"+dialPlan+"calledNbr"+calledNbr);
};

getLuaTriggerListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.dialPlan, ev.calledNbr);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.dp+"</td>");
        $("#"+indexStr).append("<td>"+ev.dialPlan+"</td>");
        $("#"+indexStr).append("<td>"+ev.calledNbr+"</td>");
        if( null != ev.description )
        {    
            $("#"+indexStr).append("<td>"+ev.description+"</td>");
        }
        else
        {
            $("#"+indexStr).append("<td></td>");
        }
        $("#"+indexStr).append("<td>"+ev.luaName+"</td>");
        $("#"+indexStr).append("<td>"+addBtnEdit(`editLuaTrigger(${ev.dp},'${ev.dialPlan}','${ev.calledNbr}')`)
                                       +addBtnDel(`delLuaTrigger(${ev.dp},'${ev.dialPlan}','${ev.calledNbr}')`)+"</td>");
    });
    
};

getLuaTriggerList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/luatrigger/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getLuaTriggerListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getLuaTriggerList);
};

gotoNextList=function() {
    pageNext(getLuaTriggerList);
};

getLuaTriggerDetailResp=function(data) {
    $.each(data, function(index, ev) {  
    
        $("#dp").val(ev.dp);
        $("#description").val(ev.description);
        $("#luaName").val(ev.luaName);
    });
};

getLuaTriggerDetail=function(dp, dial_plan, called_nbr) {
    $("#dp").val(dp);
    $("#dialPlan").val(dial_plan);
    $("#calledNbr").val(called_nbr);

    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("dp", dp)+",";
    jsonStr += jsonEncodeString("dialPlan", dial_plan)+",";
    jsonStr += jsonEncodeString("calledNbr", called_nbr);
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/luatrigger/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getLuaTriggerDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

updateLuaTriggerDetail=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeNumber("dp", $("#dp").val())+",";
    jsonStr += jsonEncodeString("dialPlan", $("#dialPlan").val())+",";
    jsonStr += jsonEncodeString("calledNbr", $("#calledNbr").val())+",";
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeString("luaName", $("#luaName").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/luatrigger/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiLuaTrigger.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiLuaTrigger.html");
        }
    });
};

delLuaTrigger=function(dp, dial_plan, called_nbr) {    
    var indexStr = buildIndexStr(dial_plan, called_nbr);
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("dp", dp)+",";
    jsonStr += jsonEncodeString("dialPlan", dial_plan)+",";
    jsonStr += jsonEncodeString("calledNbr", called_nbr);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/luatrigger/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiLuaTriggerDlg.html");
};

editLuaTrigger=function(dp,dial_plan, called_nbr) {
    var dataPost = "dp="+encodeURIComponent(dp);  
    dataPost += "&dialPlan="+encodeURIComponent(dial_plan);
    dataPost += "&calledNbr="+encodeURIComponent(called_nbr);  
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiLuaTriggerDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiLuaTrigger.html");
};
