function buildIndex(transId, calledPfx)
{
    return hex_md5("transID="+transId+"calledPfx="+calledPfx);
}

getRefineCldNbrListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {
        var indexStr = buildIndex(ev.groupID, ev.calledPrefix);
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        $("#"+indexStr).append("<td>"+ev.groupID+"</td>");        
        $("#"+indexStr).append("<td>"+ev.calledPrefix+"</td>");  
        $("#"+indexStr).append("<td>"+ev.description+"</td>");        
        $("#"+indexStr).append("<td>"+ev.transID+"</td>");
        $("#"+indexStr).append("<td>"+addBtnEdit(`editRefineCld(${ev.groupID},'${ev.calledPrefix}')`)
                                       +addBtnDel(`delRefineCld(${ev.groupID},'${ev.calledPrefix}')`)+"</td>");
    });
    
};

getRefineCldNbrList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/refinecldnbr/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getRefineCldNbrListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getRefineCldNbrList);
};

gotoNextList=function() {
    pageNext(getRefineCldNbrList);
};

getRefineCldNbrDetailResp=function(data) {   
    $.each(data, function(index, ev) {  
        $("#description").val(ev.description);  
        $("#transID").val(ev.transID);
    })
};

getRefineCldNbrDetail=function(groupID, calledPrefix) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("groupID", groupID)+",";
    jsonStr += jsonEncodeString("calledPrefix", calledPrefix)+",";
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:        "/dbajax/refinecldnbr/query",
        type:       "get",
        data:       {content:jsonStr},
        dataType:   "json",        
        success:    getRefineCldNbrDetailResp,
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

checkParamsValid=function() {
    var groupID = InputToInt("groupID");
    if( groupID <= 0)
    {
        return "'Outgoing group ID' must bigger than zero";
    }
    if( false == editBoxHasValue('calledPrefix'))
    {
        return "Please configure 'called number prefix' item.";
    }
    var transID = InputToInt("transID");
    if( transID < 0)
    {
        return "Transition ID must bigger than or equal to zero";
    }
    return "ok"
};

updateRefineCldNbrDetail=function() {
    var checkResult = checkParamsValid();
    if( "ok" != checkResult )
    {
        alertError(checkResult);
        return;
    }

    var jsonStr = "{";    
    jsonStr += jsonEncodeNumber("groupID", $("#groupID").val())+",";
    jsonStr += jsonEncodeString("calledPrefix", $("#calledPrefix").val())+",";
    jsonStr += jsonEncodeString("description", $("#description").val())+",";
    jsonStr += jsonEncodeNumber("transID", $("#transID").val())+",";
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/refinecldnbr/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiRefineCldNbr.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiRefineCldNbr.html");
        }
    });
};

delRefineCld=function(groupID, calledPrefix) {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("groupID", groupID)+",";
    jsonStr += jsonEncodeString("calledPrefix", calledPrefix)+",";
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/refinecldnbr/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) { 
            var indexStr = buildIndex(groupID, calledPrefix);          
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {   
    delIndexFromCookie(); 
    loadHtmlPage("/uiRefineCldNbrDlg.html");
};

editRefineCld=function(groupID, calledPrefix) {
    var dataPost = "groupID="+encodeURIComponent(groupID);    
    dataPost += "&calledPrefix="+encodeURIComponent(calledPrefix);
    addIndexToCookie(dataPost);
    
    loadHtmlPage("/uiRefineCldNbrDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiRefineCldNbr.html");
};


