
buildIndexStr=function(groupID, user) {
    return hex_md5("groupID"+groupID+"user"+user);
};

getRGUserListResp=function(data) {
    if(isUndefined(data.errorCode)==false) {
        // MSS returns errorCode, so it could be no more data.
        alertListError();
        return;
    }
    $("#dataRecords").empty();
    
    $.each(data, function(index, ev) {        
        var indexStr = buildIndexStr(ev.groupID, ev.user);
        
        $("#dataRecords").append("<tr id='"+indexStr+"'></tr>");
        
        $("#"+indexStr).append("<td>"+ev.groupID+"</td>");
        $("#"+indexStr).append("<td>"+ev.user+"</td>");        
        $("#"+indexStr).append("<td>"+addBtnDel(`delRGUser(${ev.groupID},'${ev.user}')`)+"</td>");
    });
    
};

getRGUserList=function() {
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("pageIndex", pageCurr());    
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/rguser/list",
        type: "get",
        dataType: "json",
        data: {content:jsonStr},
        success: getRGUserListResp,
        
        error: function(ev) {
            alertListError();
        }
    });
};

gotoPrevList=function() {
    pagePrevious(getRGUserList);
};

gotoNextList=function() {
    pageNext(getRGUserList);
};

delRGUser=function(groupID, user) {    
    var indexStr = buildIndexStr(groupID, user);
    var jsonStr = "{";
    jsonStr += jsonEncodeNumber("groupID", groupID)+",";
    jsonStr += jsonEncodeString("user", user);
    jsonStr += "}";
    
    $.ajax({
        url: "/dbajax/rguser/delete",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {  
            $('#'+indexStr).remove();
        },
        
        error: function(ev) {
            alertOperationFail();
        }
    });
};

addRGUser=function() {
    var jsonStr = "{";
    
    jsonStr += jsonEncodeNumber("groupID", $("#groupID").val())+",";
    jsonStr += jsonEncodeString("user", $("#user").val())+",";
    
    jsonStr += jsonEncodeString("endjson", "yes");
    jsonStr += "}";
    
    $.ajax({
        url:  "/dbajax/rguser/set",
        type: "get",
        data: {content:jsonStr},
        dataType: "json",        
        success: function(data) {
            alertOperationSuccess();
            loadHtmlPage("/uiRGUser.html");
        },
        
        error: function(ev) {
            alertOperationFail();
            loadHtmlPage("/uiRGUser.html");
        }
    });
};

/****************************************************

Functions for UI and Dialog

****************************************************/
addBtnOnClick = function() {    
    delIndexFromCookie(); 
    loadHtmlPage("/uiRGUserDlg.html");
};

cancelBtnOnClick = function() {    
    loadHtmlPage("/uiRGUser.html");
};
