require "services.ssf_def"

-- MSS core records details of current message
currMessage={}

--
--Service FSM definitions.
--

fsm={
    -- service datas
    calledNbr="",
    callerNbr="",
    redirNbr="",
    origDialPlan="",
    serviceNbr="",
    callerSrfID=0,
    mediaDir=0,
    foSSPInd=0,
        
    -- special service information indicators
    freeCallInd=0,
    suppressCallLevel=0,
    
    -- basic data
    profileID=0,
    scpFsmID=0,
    tracedInd=0,    
    state=0,
    procResult=0,    
    
    -- details of current message
    event=0,
    msgType=0,
    orgTask=0,
    orgFsmType=0,
    orgFsmID=0
}


function EndService()
    TraceInfo("\t EndService")
    fsm.procResult = PRC_KILL
end

function SaveMessage()
    TraceInfo("\t SaveMessage")
    fsm.procResult = PRC_SAVE
end

function HandleException()
    print(debug.traceback())
    SendReleaseCall()
    EndService()
end

function EnterState(new_state)
    TraceInfo("\t Enter state: from "..fsm.state .. " to "..new_state)
    fsm.state = new_state
end

function StartTimer(seconds)
    TraceInfo("\t start timer "..seconds.." seconds.")
    ssfStartTimer(fsm.scpFsmID, seconds)
end

function StopTimer()
    TraceInfo("\t stop timer")
    ssfStopTimer(fsm.scpFsmID)
end

function GetSsfFsmID(ssfIndex)
    if ssfIndex==nil then ssfIndex=0 end
    return ssfGetSsfFsmID(fsm.scpFsmID, ssfIndex)
end