--===================================================
--
-- DB agent for MySQL interfaces defined in MSS core
--
--===================================================

function DbPrepare()
    ssfDBPrepare()
end


function DbEnd()
    ssfDBEnd()
end


function DbQuery(sqlStr)
    return ssfDBQuery(sqlStr)
end


function DbGetRecordCnts()
    return ssfDBGetRecordCnts()
end


function DbFetchRow()
    return ssfDBFetchRow()
end


function DbGetRowIntVal(rowIndex)
    return ssfDBGetRowIntVal(rowIndex)
end


function DbGetRowStrVal(rowIndex)
    return ssfDBGetRowStrVal(rowIndex)
end


--===================================================
--
-- APIs for localDB in MSS core
--
--===================================================
function ldbQuery(sqlStr)
    return ssfLocalDBQuery(sqlStr)
end


function ldbGetRowIntVal(rowIndex)
    return ssfLocalDBGetRowIntVal(rowIndex)
end


function ldbGetRowStrVal(rowIndex)
    return ssfLocalDBGetRowStrVal(rowIndex)
end


--===================================================
--
-- APIs for cacheDB in MSS core
--
--===================================================
function cdbQuery(sqlStr)
    return ssfCacheDBQuery(sqlStr)
end

function cdbGetRowIntVal(rowIndex)
    return ssfCacheDBGetRowIntVal(rowIndex)
end

function cdbGetRowStrVal(rowIndex)
    return ssfCacheDBGetRowStrVal(rowIndex)
end

--====================================
--
-- common functions for local users
--
--====================================
local function cdbGetUserServiceRight1(userName)
    local sqlStr=string.format("select servRight10 from tbl_local_users where "..
                        "usrName='%s'", userName)
    local result = cdbQuery(sqlStr)
    if result~=MSS_ERR_OBJ_FOUND then
        return 0
    end
    return cdbGetRowIntVal(0)                        
end

function userHasOverstep(userName)
    local servRight = cdbGetUserServiceRight1(userName)
    local result = servRight & (1<<23) -- defined in MSS core
    if result>0 then  return MSS_YES else return MSS_NO end 
end